diff --git a/compiler/deSugar/MatchCon.lhs b/compiler/deSugar/MatchCon.lhs
index f2bff1e..8f1333b 100644
--- a/compiler/deSugar/MatchCon.lhs
+++ b/compiler/deSugar/MatchCon.lhs
@@ -6,18 +6,12 @@
 Pattern-matching constructors
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module MatchCon ( matchConFamily ) where
 
 #include "HsVersions.h"
 
-import {-# SOURCE #-} Match	( match )
+import {-# SOURCE #-} Match     ( match )
 
 import HsSyn
 import DsBinds
@@ -89,8 +83,8 @@ have-we-used-all-the-constructors? question; the local function
 \begin{code}
 matchConFamily :: [Id]
                -> Type
-	       -> [[EquationInfo]]
-	       -> DsM MatchResult
+               -> [[EquationInfo]]
+               -> DsM MatchResult
 -- Each group of eqns is for a single constructor
 matchConFamily (var:vars) ty groups
   = do dflags <- getDynFlags
@@ -104,45 +98,45 @@ matchOneCon :: [Id]
             -> Type
             -> [EquationInfo]
             -> DsM (DataCon, [Var], MatchResult)
-matchOneCon vars ty (eqn1 : eqns)	-- All eqns for a single constructor
-  = do	{ arg_vars <- selectConMatchVars arg_tys args1
-	 	-- Use the first equation as a source of 
-		-- suggestions for the new variables
+matchOneCon vars ty (eqn1 : eqns)       -- All eqns for a single constructor
+  = do  { arg_vars <- selectConMatchVars arg_tys args1
+                -- Use the first equation as a source of 
+                -- suggestions for the new variables
 
-	-- Divide into sub-groups; see Note [Record patterns]
+        -- Divide into sub-groups; see Note [Record patterns]
         ; let groups :: [[(ConArgPats, EquationInfo)]]
-	      groups = runs compatible_pats [ (pat_args (firstPat eqn), eqn) 
-	      	       	    	            | eqn <- eqn1:eqns ]
+              groups = runs compatible_pats [ (pat_args (firstPat eqn), eqn) 
+                                            | eqn <- eqn1:eqns ]
 
-	; match_results <- mapM (match_group arg_vars) groups
+        ; match_results <- mapM (match_group arg_vars) groups
 
-      	; return (con1, tvs1 ++ dicts1 ++ arg_vars, 
-		  foldr1 combineMatchResults match_results) }
+        ; return (con1, tvs1 ++ dicts1 ++ arg_vars, 
+                  foldr1 combineMatchResults match_results) }
   where
     ConPatOut { pat_con = L _ con1, pat_ty = pat_ty1,
-	        pat_tvs = tvs1, pat_dicts = dicts1, pat_args = args1 }
-	      = firstPat eqn1
+                pat_tvs = tvs1, pat_dicts = dicts1, pat_args = args1 }
+              = firstPat eqn1
     fields1 = dataConFieldLabels con1
-	
+        
     arg_tys  = dataConInstOrigArgTys con1 inst_tys
     inst_tys = tcTyConAppArgs pat_ty1 ++ 
-	       mkTyVarTys (takeList (dataConExTyVars con1) tvs1)
-	-- Newtypes opaque, hence tcTyConAppArgs
-	-- dataConInstOrigArgTys takes the univ and existential tyvars
-	-- and returns the types of the *value* args, which is what we want
+               mkTyVarTys (takeList (dataConExTyVars con1) tvs1)
+        -- Newtypes opaque, hence tcTyConAppArgs
+        -- dataConInstOrigArgTys takes the univ and existential tyvars
+        -- and returns the types of the *value* args, which is what we want
 
     match_group :: [Id] -> [(ConArgPats, EquationInfo)] -> DsM MatchResult
     -- All members of the group have compatible ConArgPats
     match_group arg_vars arg_eqn_prs
       = ASSERT( notNull arg_eqn_prs )
         do { (wraps, eqns') <- liftM unzip (mapM shift arg_eqn_prs)
-    	   ; let group_arg_vars = select_arg_vars arg_vars arg_eqn_prs
-    	   ; match_result <- match (group_arg_vars ++ vars) ty eqns'
-    	   ; return (adjustMatchResult (foldr1 (.) wraps) match_result) }
+           ; let group_arg_vars = select_arg_vars arg_vars arg_eqn_prs
+           ; match_result <- match (group_arg_vars ++ vars) ty eqns'
+           ; return (adjustMatchResult (foldr1 (.) wraps) match_result) }
 
     shift (_, eqn@(EqnInfo { eqn_pats = ConPatOut{ pat_tvs = tvs, pat_dicts = ds, 
-					           pat_binds = bind, pat_args = args
-					} : pats }))
+                                                   pat_binds = bind, pat_args = args
+                                        } : pats }))
       = do ds_bind <- dsTcEvBinds bind
            return ( wrapBinds (tvs `zip` tvs1)
                   . wrapBinds (ds  `zip` dicts1)
@@ -164,8 +158,8 @@ matchOneCon vars ty (eqn1 : eqns)	-- All eqns for a single constructor
       = arg_vars
       where
         fld_var_env = mkNameEnv $ zipEqual "get_arg_vars" fields1 arg_vars
-	lookup_fld rpat = lookupNameEnv_NF fld_var_env 
-		   	  		   (idName (unLoc (hsRecFieldId rpat)))
+        lookup_fld rpat = lookupNameEnv_NF fld_var_env 
+                                           (idName (unLoc (hsRecFieldId rpat)))
     select_arg_vars _ [] = panic "matchOneCon/select_arg_vars []"
 matchOneCon _ _ [] = panic "matchOneCon []"
 
@@ -181,7 +175,7 @@ compatible_pats _                 _                 = True -- Prefix or infix co
 same_fields :: HsRecFields Id (LPat Id) -> HsRecFields Id (LPat Id) -> Bool
 same_fields flds1 flds2 
   = all2 (\f1 f2 -> unLoc (hsRecFieldId f1) == unLoc (hsRecFieldId f2))
-	 (rec_flds flds1) (rec_flds flds2)
+         (rec_flds flds1) (rec_flds flds2)
 
 
 -----------------
@@ -190,26 +184,26 @@ selectConMatchVars arg_tys (RecCon {})      = newSysLocalsDs arg_tys
 selectConMatchVars _       (PrefixCon ps)   = selectMatchVars (map unLoc ps)
 selectConMatchVars _       (InfixCon p1 p2) = selectMatchVars [unLoc p1, unLoc p2]
 
-conArgPats :: [Type]	-- Instantiated argument types 
-			-- Used only to fill in the types of WildPats, which
-			-- are probably never looked at anyway
-	   -> ConArgPats
-	   -> [Pat Id]
+conArgPats :: [Type]    -- Instantiated argument types 
+                        -- Used only to fill in the types of WildPats, which
+                        -- are probably never looked at anyway
+           -> ConArgPats
+           -> [Pat Id]
 conArgPats _arg_tys (PrefixCon ps)   = map unLoc ps
 conArgPats _arg_tys (InfixCon p1 p2) = [unLoc p1, unLoc p2]
 conArgPats  arg_tys (RecCon (HsRecFields { rec_flds = rpats }))
   | null rpats = map WildPat arg_tys
-	-- Important special case for C {}, which can be used for a 
- 	-- datacon that isn't declared to have fields at all
+        -- Important special case for C {}, which can be used for a 
+        -- datacon that isn't declared to have fields at all
   | otherwise  = map (unLoc . hsRecFieldArg) rpats
 \end{code}
 
 Note [Record patterns]
 ~~~~~~~~~~~~~~~~~~~~~~
 Consider 
-	 data T = T { x,y,z :: Bool }
+         data T = T { x,y,z :: Bool }
 
-	 f (T { y=True, x=False }) = ...
+         f (T { y=True, x=False }) = ...
 
 We must match the patterns IN THE ORDER GIVEN, thus for the first
 one we match y=True before x=False.  See Trac #246; or imagine 
@@ -218,8 +212,8 @@ touching the undefined.
 
 Now consider:
 
-	 f (T { y=True, x=False }) = ...
-	 f (T { x=True, y= False}) = ...
+         f (T { y=True, x=False }) = ...
+         f (T { x=True, y= False}) = ...
 
 In the first we must test y first; in the second we must test x 
 first.  So we must divide even the equations for a single constructor
@@ -235,31 +229,31 @@ Hence the (null rpats) checks here and there.
 Note [Existentials in shift_con_pat]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Consider
-	data T = forall a. Ord a => T a (a->Int)
+        data T = forall a. Ord a => T a (a->Int)
 
-	f (T x f) True  = ...expr1...
-	f (T y g) False = ...expr2..
+        f (T x f) True  = ...expr1...
+        f (T y g) False = ...expr2..
 
 When we put in the tyvars etc we get
 
-	f (T a (d::Ord a) (x::a) (f::a->Int)) True =  ...expr1...
-	f (T b (e::Ord b) (y::a) (g::a->Int)) True =  ...expr2...
+        f (T a (d::Ord a) (x::a) (f::a->Int)) True =  ...expr1...
+        f (T b (e::Ord b) (y::a) (g::a->Int)) True =  ...expr2...
 
 After desugaring etc we'll get a single case:
 
-	f = \t::T b::Bool -> 
-	    case t of
-	       T a (d::Ord a) (x::a) (f::a->Int)) ->
-	    case b of
-		True  -> ...expr1...
-		False -> ...expr2...
+        f = \t::T b::Bool -> 
+            case t of
+               T a (d::Ord a) (x::a) (f::a->Int)) ->
+            case b of
+                True  -> ...expr1...
+                False -> ...expr2...
 
 *** We have to substitute [a/b, d/e] in expr2! **
 Hence
-		False -> ....((/\b\(e:Ord b).expr2) a d)....
+                False -> ....((/\b\(e:Ord b).expr2) a d)....
 
 Originally I tried to use 
-	(\b -> let e = d in expr2) a 
+        (\b -> let e = d in expr2) a 
 to do this substitution.  While this is "correct" in a way, it fails
 Lint, because e::Ord b but d::Ord a.  
 
diff --git a/compiler/ghci/ByteCodeGen.lhs b/compiler/ghci/ByteCodeGen.lhs
index 25f6b66..ca6f440 100644
--- a/compiler/ghci/ByteCodeGen.lhs
+++ b/compiler/ghci/ByteCodeGen.lhs
@@ -5,12 +5,6 @@
 ByteCodeGen: Generate bytecode from Core
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module ByteCodeGen ( UnlinkedBCO, byteCodeGen, coreExprToBCOs ) where
 
@@ -842,8 +836,8 @@ doCase d s p (_,scrut) bndr alts is_unboxed_tuple
              MASSERT(isAlgCase)
              rhs_code <- schemeE (d_alts + size) s p' rhs
              return (my_discr alt, unitOL (UNPACK (trunc16 size)) `appOL` rhs_code)
-	   where
-	     real_bndrs = filterOut isTyVar bndrs
+           where
+             real_bndrs = filterOut isTyVar bndrs
 
         my_discr (DEFAULT, _, _) = NoDiscr {-shouldn't really happen-}
         my_discr (DataAlt dc, _, _)
@@ -1205,8 +1199,8 @@ pushAtom d p e
    | Just e' <- bcView e
    = pushAtom d p e'
 
-pushAtom _ _ (AnnCoercion {})	-- Coercions are zero-width things, 
-   = return (nilOL, 0)	  	-- treated just like a variable V
+pushAtom _ _ (AnnCoercion {})   -- Coercions are zero-width things, 
+   = return (nilOL, 0)          -- treated just like a variable V
 
 pushAtom d p (AnnVar v)
    | UnaryRep rep_ty <- repType (idType v)
@@ -1516,12 +1510,12 @@ isVAtom :: AnnExpr' Var ann -> Bool
 isVAtom e | Just e' <- bcView e = isVAtom e'
 isVAtom (AnnVar v)              = isVoidArg (bcIdArgRep v)
 isVAtom (AnnCoercion {})        = True
-isVAtom _ 	              = False
+isVAtom _                     = False
 
 atomPrimRep :: AnnExpr' Id ann -> PrimRep
 atomPrimRep e | Just e' <- bcView e = atomPrimRep e'
-atomPrimRep (AnnVar v)    	    = bcIdPrimRep v
-atomPrimRep (AnnLit l)    	    = typePrimRep (literalType l)
+atomPrimRep (AnnVar v)              = bcIdPrimRep v
+atomPrimRep (AnnLit l)              = typePrimRep (literalType l)
 atomPrimRep (AnnCoercion {})        = VoidRep
 atomPrimRep other = pprPanic "atomPrimRep" (ppr (deAnnotate (undefined,other)))
 
diff --git a/compiler/ghci/ByteCodeInstr.lhs b/compiler/ghci/ByteCodeInstr.lhs
index 005a430..550d8ad 100644
--- a/compiler/ghci/ByteCodeInstr.lhs
+++ b/compiler/ghci/ByteCodeInstr.lhs
@@ -4,23 +4,17 @@
 ByteCodeInstrs: Bytecode instruction definitions
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 {-# OPTIONS_GHC -funbox-strict-fields #-}
 
 module ByteCodeInstr ( 
- 	BCInstr(..), ProtoBCO(..), bciStackUse, BreakInfo (..) 
+        BCInstr(..), ProtoBCO(..), bciStackUse, BreakInfo (..) 
   ) where
 
 #include "HsVersions.h"
 #include "../includes/MachDeps.h"
 
-import ByteCodeItbls	( ItblPtr )
+import ByteCodeItbls    ( ItblPtr )
 
 import StgCmmLayout     ( ArgRep(..) )
 import PprCore
@@ -45,15 +39,15 @@ import Data.Word
 
 data ProtoBCO a 
    = ProtoBCO { 
-	protoBCOName       :: a,	  -- name, in some sense
-	protoBCOInstrs     :: [BCInstr],  -- instrs
-	-- arity and GC info
-	protoBCOBitmap     :: [StgWord],
-	protoBCOBitmapSize :: Word16,
-	protoBCOArity	   :: Int,
-	-- what the BCO came from
-	protoBCOExpr       :: Either  [AnnAlt Id VarSet] (AnnExpr Id VarSet),
-	-- malloc'd pointers
+        protoBCOName       :: a,          -- name, in some sense
+        protoBCOInstrs     :: [BCInstr],  -- instrs
+        -- arity and GC info
+        protoBCOBitmap     :: [StgWord],
+        protoBCOBitmapSize :: Word16,
+        protoBCOArity      :: Int,
+        -- what the BCO came from
+        protoBCOExpr       :: Either  [AnnAlt Id VarSet] (AnnExpr Id VarSet),
+        -- malloc'd pointers
         protoBCOPtrs       :: [Either ItblPtr (Ptr ())]
    }
 
@@ -79,14 +73,14 @@ data BCInstr
 
    -- Pushing literals
    | PUSH_UBX  (Either Literal (Ptr ())) Word16
-	-- push this int/float/double/addr, on the stack. Word16
-	-- is # of words to copy from literal pool.  Eitherness reflects
-	-- the difficulty of dealing with MachAddr here, mostly due to
-	-- the excessive (and unnecessary) restrictions imposed by the
-	-- designers of the new Foreign library.  In particular it is
-	-- quite impossible to convert an Addr to any other integral
-	-- type, and it appears impossible to get hold of the bits of
-	-- an addr, even though we need to assemble BCOs.
+        -- push this int/float/double/addr, on the stack. Word16
+        -- is # of words to copy from literal pool.  Eitherness reflects
+        -- the difficulty of dealing with MachAddr here, mostly due to
+        -- the excessive (and unnecessary) restrictions imposed by the
+        -- designers of the new Foreign library.  In particular it is
+        -- quite impossible to convert an Addr to any other integral
+        -- type, and it appears impossible to get hold of the bits of
+        -- an addr, even though we need to assemble BCOs.
 
    -- various kinds of application
    | PUSH_APPLY_N
@@ -111,8 +105,8 @@ data BCInstr
    | MKPAP     !Word16{-ptr to PAP is this far down stack-} !Word16{-number of words-}
    | UNPACK    !Word16 -- unpack N words from t.o.s Constr
    | PACK      DataCon !Word16
-			-- after assembly, the DataCon is an index into the
-			-- itbl array
+                        -- after assembly, the DataCon is an index into the
+                        -- itbl array
    -- For doing case trees
    | LABEL     LocalLabel
    | TESTLT_I  Int    LocalLabel
@@ -146,7 +140,7 @@ data BCInstr
 
    -- To Infinity And Beyond
    | ENTER
-   | RETURN		-- return a lifted value
+   | RETURN             -- return a lifted value
    | RETURN_UBX ArgRep -- return an unlifted value, here's its rep
 
    -- Breakpoints 
@@ -173,7 +167,7 @@ instance Outputable BreakInfo where
 instance Outputable a => Outputable (ProtoBCO a) where
    ppr (ProtoBCO name instrs bitmap bsize arity origin malloced)
       = (text "ProtoBCO" <+> ppr name <> char '#' <> int arity 
-		<+> text (show malloced) <> colon)
+                <+> text (show malloced) <> colon)
         $$ nest 3 (case origin of
                       Left alts -> vcat (zipWith (<+>) (char '{' : repeat (char ';'))
                                                        (map (pprCoreAltShort.deAnnAlt) alts)) <+> char '}'
@@ -211,7 +205,7 @@ instance Outputable BCInstr where
    ppr (PUSH_L offset)       = text "PUSH_L  " <+> ppr offset
    ppr (PUSH_LL o1 o2)       = text "PUSH_LL " <+> ppr o1 <+> ppr o2
    ppr (PUSH_LLL o1 o2 o3)   = text "PUSH_LLL" <+> ppr o1 <+> ppr o2 <+> ppr o3
-   ppr (PUSH_G nm)  	     = text "PUSH_G  " <+> ppr nm
+   ppr (PUSH_G nm)           = text "PUSH_G  " <+> ppr nm
    ppr (PUSH_PRIMOP op)      = text "PUSH_G  " <+> text "GHC.PrimopWrappers." 
                                                <> ppr op
    ppr (PUSH_BCO bco)        = hang (text "PUSH_BCO") 2 (ppr bco)
@@ -220,17 +214,17 @@ instance Outputable BCInstr where
 
    ppr (PUSH_UBX (Left lit) nw) = text "PUSH_UBX" <+> parens (ppr nw) <+> ppr lit
    ppr (PUSH_UBX (Right aa) nw) = text "PUSH_UBX" <+> parens (ppr nw) <+> text (show aa)
-   ppr PUSH_APPLY_N		= text "PUSH_APPLY_N"
-   ppr PUSH_APPLY_V		= text "PUSH_APPLY_V"
-   ppr PUSH_APPLY_F		= text "PUSH_APPLY_F"
-   ppr PUSH_APPLY_D		= text "PUSH_APPLY_D"
-   ppr PUSH_APPLY_L		= text "PUSH_APPLY_L"
-   ppr PUSH_APPLY_P		= text "PUSH_APPLY_P"
-   ppr PUSH_APPLY_PP		= text "PUSH_APPLY_PP"
-   ppr PUSH_APPLY_PPP		= text "PUSH_APPLY_PPP"
-   ppr PUSH_APPLY_PPPP		= text "PUSH_APPLY_PPPP"
-   ppr PUSH_APPLY_PPPPP		= text "PUSH_APPLY_PPPPP"
-   ppr PUSH_APPLY_PPPPPP	= text "PUSH_APPLY_PPPPPP"
+   ppr PUSH_APPLY_N             = text "PUSH_APPLY_N"
+   ppr PUSH_APPLY_V             = text "PUSH_APPLY_V"
+   ppr PUSH_APPLY_F             = text "PUSH_APPLY_F"
+   ppr PUSH_APPLY_D             = text "PUSH_APPLY_D"
+   ppr PUSH_APPLY_L             = text "PUSH_APPLY_L"
+   ppr PUSH_APPLY_P             = text "PUSH_APPLY_P"
+   ppr PUSH_APPLY_PP            = text "PUSH_APPLY_PP"
+   ppr PUSH_APPLY_PPP           = text "PUSH_APPLY_PPP"
+   ppr PUSH_APPLY_PPPP          = text "PUSH_APPLY_PPPP"
+   ppr PUSH_APPLY_PPPPP         = text "PUSH_APPLY_PPPPP"
+   ppr PUSH_APPLY_PPPPPP        = text "PUSH_APPLY_PPPPPP"
 
    ppr (SLIDE n d)           = text "SLIDE   " <+> ppr n <+> ppr d
    ppr (ALLOC_AP sz)         = text "ALLOC_AP   " <+> ppr sz
@@ -256,7 +250,7 @@ instance Outputable BCInstr where
    ppr CASEFAIL              = text "CASEFAIL"
    ppr (JMP lab)             = text "JMP"      <+> ppr lab
    ppr (CCALL off marshall_addr int) = text "CCALL   " <+> ppr off 
-						<+> text "marshall code at" 
+                                                <+> text "marshall code at" 
                                                <+> text (show marshall_addr)
                                                <+> (if int == 1
                                                     then text "(interruptible)"
@@ -264,7 +258,7 @@ instance Outputable BCInstr where
    ppr (SWIZZLE stkoff n)    = text "SWIZZLE " <+> text "stkoff" <+> ppr stkoff
                                                <+> text "by" <+> ppr n
    ppr ENTER                 = text "ENTER"
-   ppr RETURN		     = text "RETURN"
+   ppr RETURN                = text "RETURN"
    ppr (RETURN_UBX pk)       = text "RETURN_UBX  " <+> ppr pk
    ppr (BRK_FUN _breakArray index info) = text "BRK_FUN" <+> text "<array>" <+> ppr index <+> ppr info
 
@@ -283,54 +277,54 @@ protoBCOStackUse bco = sum (map bciStackUse (protoBCOInstrs bco))
 
 bciStackUse :: BCInstr -> Word
 bciStackUse STKCHECK{}            = 0
-bciStackUse PUSH_L{}       	  = 1
-bciStackUse PUSH_LL{}       	  = 2
+bciStackUse PUSH_L{}              = 1
+bciStackUse PUSH_LL{}             = 2
 bciStackUse PUSH_LLL{}            = 3
-bciStackUse PUSH_G{} 		  = 1
+bciStackUse PUSH_G{}              = 1
 bciStackUse PUSH_PRIMOP{}         = 1
-bciStackUse PUSH_BCO{}    	  = 1
+bciStackUse PUSH_BCO{}            = 1
 bciStackUse (PUSH_ALTS bco)       = 2 + protoBCOStackUse bco
 bciStackUse (PUSH_ALTS_UNLIFTED bco _) = 2 + protoBCOStackUse bco
 bciStackUse (PUSH_UBX _ nw)       = fromIntegral nw
-bciStackUse PUSH_APPLY_N{}	  = 1
-bciStackUse PUSH_APPLY_V{}	  = 1
-bciStackUse PUSH_APPLY_F{}	  = 1
-bciStackUse PUSH_APPLY_D{}	  = 1
-bciStackUse PUSH_APPLY_L{}	  = 1
-bciStackUse PUSH_APPLY_P{}	  = 1
-bciStackUse PUSH_APPLY_PP{}	  = 1
-bciStackUse PUSH_APPLY_PPP{}	  = 1
-bciStackUse PUSH_APPLY_PPPP{}	  = 1
-bciStackUse PUSH_APPLY_PPPPP{}	  = 1
-bciStackUse PUSH_APPLY_PPPPPP{}	  = 1
+bciStackUse PUSH_APPLY_N{}        = 1
+bciStackUse PUSH_APPLY_V{}        = 1
+bciStackUse PUSH_APPLY_F{}        = 1
+bciStackUse PUSH_APPLY_D{}        = 1
+bciStackUse PUSH_APPLY_L{}        = 1
+bciStackUse PUSH_APPLY_P{}        = 1
+bciStackUse PUSH_APPLY_PP{}       = 1
+bciStackUse PUSH_APPLY_PPP{}      = 1
+bciStackUse PUSH_APPLY_PPPP{}     = 1
+bciStackUse PUSH_APPLY_PPPPP{}    = 1
+bciStackUse PUSH_APPLY_PPPPPP{}   = 1
 bciStackUse ALLOC_AP{}            = 1
 bciStackUse ALLOC_AP_NOUPD{}      = 1
 bciStackUse ALLOC_PAP{}           = 1
 bciStackUse (UNPACK sz)           = fromIntegral sz
-bciStackUse LABEL{}       	  = 0
-bciStackUse TESTLT_I{}     	  = 0
-bciStackUse TESTEQ_I{}     	  = 0
-bciStackUse TESTLT_W{}     	  = 0
-bciStackUse TESTEQ_W{}     	  = 0
-bciStackUse TESTLT_F{}     	  = 0
-bciStackUse TESTEQ_F{}     	  = 0
-bciStackUse TESTLT_D{}     	  = 0
-bciStackUse TESTEQ_D{}     	  = 0
-bciStackUse TESTLT_P{}     	  = 0
-bciStackUse TESTEQ_P{}     	  = 0
-bciStackUse CASEFAIL{}		  = 0
-bciStackUse JMP{}		  = 0
-bciStackUse ENTER{}		  = 0
-bciStackUse RETURN{}		  = 0
-bciStackUse RETURN_UBX{}	  = 1
-bciStackUse CCALL{} 		  = 0
-bciStackUse SWIZZLE{}    	  = 0
-bciStackUse BRK_FUN{}    	  = 0
+bciStackUse LABEL{}               = 0
+bciStackUse TESTLT_I{}            = 0
+bciStackUse TESTEQ_I{}            = 0
+bciStackUse TESTLT_W{}            = 0
+bciStackUse TESTEQ_W{}            = 0
+bciStackUse TESTLT_F{}            = 0
+bciStackUse TESTEQ_F{}            = 0
+bciStackUse TESTLT_D{}            = 0
+bciStackUse TESTEQ_D{}            = 0
+bciStackUse TESTLT_P{}            = 0
+bciStackUse TESTEQ_P{}            = 0
+bciStackUse CASEFAIL{}            = 0
+bciStackUse JMP{}                 = 0
+bciStackUse ENTER{}               = 0
+bciStackUse RETURN{}              = 0
+bciStackUse RETURN_UBX{}          = 1
+bciStackUse CCALL{}               = 0
+bciStackUse SWIZZLE{}             = 0
+bciStackUse BRK_FUN{}             = 0
 
 -- These insns actually reduce stack use, but we need the high-tide level,
 -- so can't use this info.  Not that it matters much.
-bciStackUse SLIDE{}		  = 0
-bciStackUse MKAP{}		  = 0
-bciStackUse MKPAP{}		  = 0
-bciStackUse PACK{}		  = 1 -- worst case is PACK 0 words
+bciStackUse SLIDE{}               = 0
+bciStackUse MKAP{}                = 0
+bciStackUse MKPAP{}               = 0
+bciStackUse PACK{}                = 1 -- worst case is PACK 0 words
 \end{code}
diff --git a/compiler/ghci/RtClosureInspect.hs b/compiler/ghci/RtClosureInspect.hs
index 53fed72..5a111fd 100644
--- a/compiler/ghci/RtClosureInspect.hs
+++ b/compiler/ghci/RtClosureInspect.hs
@@ -6,12 +6,6 @@
 --
 -----------------------------------------------------------------------------
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module RtClosureInspect(
      cvObtainTerm,      -- :: HscEnv -> Int -> Bool -> Maybe Type -> HValue -> IO Term
@@ -358,8 +352,8 @@ ppr_termM y p Term{dc=Right dc, subTerms=tt}
        ; return $ cparen (p >= app_prec) $
          sep [ppr dc, nest 2 (pprDeeperList fsep tt_docs)] }
   where
-    sub_terms_to_show	-- Don't show the dictionary arguments to 
-    			-- constructors unless -dppr-debug is on
+    sub_terms_to_show   -- Don't show the dictionary arguments to 
+                        -- constructors unless -dppr-debug is on
       | opt_PprStyle_Debug = tt
       | otherwise = dropList (dataConTheta dc) tt
 
@@ -472,7 +466,7 @@ cPprTermBase y =
    ppr_list p (Term{subTerms=[h,t]}) = do
        let elems      = h : getListTerms t
            isConsLast = not(termType(last elems) `eqType` termType h)
-   	   is_string  = all (isCharTy . ty) elems
+           is_string  = all (isCharTy . ty) elems
 
        print_elems <- mapM (y cons_prec) elems
        if is_string
@@ -750,7 +744,7 @@ cvObtainTerm hsc_env max_depth force old_ty hval = runTR hsc_env $ do
                         -- In such case, we return a best approximation:
                         --  ignore the unpointed args, and recover the pointeds
                         -- This preserves laziness, and should be safe.
-		       traceTR (text "Not constructor" <+> ppr dcname)
+                       traceTR (text "Not constructor" <+> ppr dcname)
                        let dflags = hsc_dflags hsc_env
                            tag = showPpr dflags dcname
                        vars     <- replicateM (length$ elems$ ptrs clos) 
@@ -945,17 +939,17 @@ getDataConArgTys dc con_app_ty
        ; traceTR (text "getDataConArgTys 1" <+> (ppr con_app_ty $$ ppr rep_con_app_ty))
        ; ty_args <- case tcSplitTyConApp_maybe rep_con_app_ty of
                        Just (tc, ty_args) | dataConTyCon dc == tc
-		       	   -> ASSERT( univ_tvs `equalLength` ty_args) 
+                           -> ASSERT( univ_tvs `equalLength` ty_args) 
                               return ty_args
- 		       _   -> do { (_, ty_args, univ_subst) <- instTyVars univ_tvs
-		       	         ; let res_ty = substTy ex_subst (substTy univ_subst (dataConOrigResTy dc))
+                       _   -> do { (_, ty_args, univ_subst) <- instTyVars univ_tvs
+                                 ; let res_ty = substTy ex_subst (substTy univ_subst (dataConOrigResTy dc))
                                    -- See Note [Constructor arg types]
                                  ; addConstraint rep_con_app_ty res_ty
                                  ; return ty_args }
-		-- It is necessary to check dataConTyCon dc == tc
-      		-- because it may be the case that tc is a recursive
-      		-- newtype and tcSplitTyConApp has not removed it. In
-      		-- that case, we happily give up and don't match
+                -- It is necessary to check dataConTyCon dc == tc
+                -- because it may be the case that tc is a recursive
+                -- newtype and tcSplitTyConApp has not removed it. In
+                -- that case, we happily give up and don't match
        ; let subst = zipTopTvSubst (univ_tvs ++ ex_tvs) (ty_args ++ ex_tys)
        ; traceTR (text "getDataConArgTys 2" <+> (ppr rep_con_app_ty $$ ppr ty_args $$ ppr subst))
        ; return (substTys subst (dataConRepArgTys dc)) }
@@ -1212,10 +1206,10 @@ zonkRttiType = zonkTcTypeToType (mkEmptyZonkEnv zonk_unbound_meta)
     zonk_unbound_meta tv 
       = ASSERT( isTcTyVar tv )
         do { tv' <- skolemiseUnboundMetaTyVar tv RuntimeUnk
-	     -- This is where RuntimeUnks are born: 
-	     -- otherwise-unconstrained unification variables are
-	     -- turned into RuntimeUnks as they leave the
-	     -- typechecker's monad
+             -- This is where RuntimeUnks are born: 
+             -- otherwise-unconstrained unification variables are
+             -- turned into RuntimeUnks as they leave the
+             -- typechecker's monad
            ; return (mkTyVarTy tv') }
 
 --------------------------------------------------------------------------------
